/*
 * EJBProxyInvicationHandler.java
 *
 * Created on 13 novembre 2000, 22.55
 */

package ejbtechnique;

/**
 *
 * @author  Administrator
 * @version
 */
public class DefaultEJBProxyInvocationHandler extends java.lang.Object implements java.lang.reflect.InvocationHandler, java.io.Serializable {
    javax.ejb.Handle remoteHandle;
    java.util.Map attributeMap;
    Class businessInterface;

    /** Creates new EJBProxyInvicationHandler */
    public DefaultEJBProxyInvocationHandler(Class businessInterface,javax.ejb.Handle remoteHandle,java.util.Map initialAttributeValues) throws java.rmi.RemoteException{
        this.remoteHandle=remoteHandle;
        this.attributeMap=initialAttributeValues;
        this.businessInterface=businessInterface;
    }

    public java.lang.Object invoke(final java.lang.Object obj,java.lang.reflect.Method method,java.lang.Object[] args) throws java.lang.Throwable {
        //System.out.println(this.getClass().toString()+": invoke method called");
        if (method.getName().equals("update") && (args==null || args.length==0)){
            Proxiable PI=(Proxiable)obj;
            PI.bulkSetAttribute(attributeMap);
            attributeMap.put("versionID",new Integer(((Integer)attributeMap.get("versionID")).intValue()+1));
            return null;
        }
        if (method.getName().startsWith("get") && (args==null || args.length==0)){
            String attribute=method.getName().substring(3);
            attribute=attribute.substring(0,1).toLowerCase()+attribute.substring(1);
            return getMethod(attribute,method,args);
        }
        if (method.getName().startsWith("set") && (args!=null || args.length==1)){
            String attribute=method.getName().substring(3);
            attribute=attribute.substring(0,1).toLowerCase()+attribute.substring(1);
            setMethod(attribute,method,args);
            return null;
        }
        return commonMethod(method,args);
    }




    protected Object commonMethod(java.lang.reflect.Method method,java.lang.Object[] args) throws java.rmi.RemoteException {
        //System.out.println(this.getClass().toString()+": commonMethod method called");
        try {
            javax.ejb.EJBObject remoteBean=getEJBObject();
            System.out.println(method);
            System.out.println(remoteBean.getClass());
            System.out.println(java.util.Arrays.asList(remoteBean.getClass().getInterfaces()));
            return method.invoke(remoteBean,args);
        }
        catch (java.lang.reflect.InvocationTargetException e){
            //this should never happen
            java.io.StringWriter SW=new java.io.StringWriter();
            e.printStackTrace(System.out);
            throw new java.rmi.RemoteException(e.getMessage());
        }
        catch (IllegalAccessException e){
            //this should never happen
            throw new java.rmi.RemoteException(e.getMessage());
        }

    }

    protected Object getMethod(String name,java.lang.reflect.Method method,Object[] args) throws java.rmi.RemoteException {
        //System.out.println(this.getClass().toString()+": getMethod method called");
        Object res=attributeMap.get(name);
        try {
            if (res==null){
                javax.ejb.EJBObject remoteObject=getEJBObject();
                res=method.invoke(remoteObject,args);
                attributeMap.put(name,res);
            }
        }
        catch (java.lang.reflect.InvocationTargetException e){
            //this should never happen
            throw new java.rmi.RemoteException(e.getMessage());
        }
        catch (IllegalAccessException e){
            //this should never happen
            throw new java.rmi.RemoteException(e.getMessage());
        }
        return res;
    }

    protected void setMethod(String name,java.lang.reflect.Method method,Object[] args){
        //System.out.println(this.getClass().toString()+": setMethod method called");
        attributeMap.put(name,args[0]);
    }


    protected javax.ejb.EJBObject getEJBObject() throws java.rmi.RemoteException {
        //System.out.println(this.getClass().toString()+": getEJBObject method called");
        return (javax.ejb.EJBObject)javax.rmi.PortableRemoteObject.narrow(remoteHandle.getEJBObject(),businessInterface);
   }
}
