/*
 * ProxyObject.java
 *
 * Created on 13 novembre 2000, 23.34
 */

package ejbtechnique;

/**
 *
 * @author  Administrator
 * @version
 */
public class ProxyDelegate extends java.lang.Object implements Proxiable {
    javax.ejb.EnterpriseBean BeanObject;
    /** Creates new ProxyObject */
    public ProxyDelegate(javax.ejb.EnterpriseBean BeanObject) throws java.rmi.RemoteException {
        this.BeanObject=BeanObject;
        if (!(BeanObject instanceof Versionable)){
          throw new IllegalArgumentException ("BeanObject must be Versionable");
        }
    }

    public void bulkSetAttribute(java.util.Map attributeMap) throws java.rmi.RemoteException {
        //System.out.println(this.getClass().toString()+": bulkSetAttribute method called");
        Integer oldVersionID=(Integer)attributeMap.remove("versionID");
        Integer actualVersionID=((Versionable)BeanObject).getVersionID();
        if (!oldVersionID.equals(actualVersionID)){
          throw new IllegalStateException ("dirty read condition");
        }
        java.util.Set keySet=attributeMap.keySet();
        java.util.Iterator i=keySet.iterator();
        try{
            while (i.hasNext()){
                String attribute=i.next().toString();
                String firstLetter=attribute.substring(0,1).toUpperCase();
                String rest=attribute.substring(1);
                Object value=attributeMap.get(attribute);
                Class[] argsClasses={value.getClass()};
                java.lang.reflect.Method method=BeanObject.getClass().getMethod("set"+firstLetter+rest,argsClasses);
                Object[] args={value};
                method.invoke(BeanObject,args);
            }
        }
        catch(NoSuchMethodException e){
            //a property in the map does not exists
            throw new IllegalArgumentException();
        }
        catch(IllegalAccessException e){
            //this should never happen
            throw new javax.ejb.EJBException(e);
        }
        catch(java.lang.reflect.InvocationTargetException e){
            //this should never happer
            throw new javax.ejb.EJBException(e);
        }
        ((Versionable)BeanObject).setVersionID(new Integer(actualVersionID.intValue()+1));
    }

    public java.util.Map bulkGetAttribute(java.util.Set attributeSet) throws java.rmi.RemoteException {
        //System.out.println(this.getClass().toString()+": bulkGetAttribute method called");
        java.util.Iterator i=attributeSet.iterator();
        java.util.Map attributeMap=new java.util.HashMap();
        try{
            while(i.hasNext()){
                String attribute=i.next().toString();
                String firstLetter=attribute.substring(0,1).toUpperCase();
                String rest=attribute.substring(1);
                Class[] argsClasses={};
                System.out.println("method name:"+"get"+firstLetter+rest);
                java.lang.reflect.Method method=BeanObject.getClass().getMethod("get"+firstLetter+rest,argsClasses);
                Object[] args={};
                Object value=method.invoke(BeanObject,args);
                attributeMap.put(attribute,value);
            }
        }
        catch(NoSuchMethodException e){
            //a property in the map does not exists
            throw new IllegalArgumentException();
        }
        catch(IllegalAccessException e){
            //this should never happen
            throw new javax.ejb.EJBException(e);
        }
        catch(java.lang.reflect.InvocationTargetException e){
            //this should never happer
            throw new javax.ejb.EJBException(e);
        }
        attributeMap.put("versionID",((Versionable)BeanObject).getVersionID());
        return attributeMap;
    }

   public java.util.Map getAllAttributes() throws java.rmi.RemoteException {
      //System.out.println(this.getClass().toString()+": getAllAttributes method called");
      java.util.Set attributeSet=new java.util.HashSet();
      attributeSet.add("string");
      return bulkGetAttribute(attributeSet);
    }

}



